/****************************************************************************
** DialogImages
**
**   Created : Sun Apr 27 22:48:00 2008
**        by : Varol Okan using Kate
** Copyright : (c) Varol Okan
**   License : GPL v 2.0
**
** This dialog offers an easy way to create slideshows from a selection
** of images.
**
** This of course is helpfull if you have 100+ files
**
****************************************************************************/

#ifndef __DIALOGIMAGES_H__
#define __DIALOGIMAGES_H__

#include "dialogfiles.h"

// Separate from global namspace because nested classes 
// are not supported by moc.

class CXmlSlideshow;

namespace Input
{

class DialogImages : public DialogFiles
{
  Q_OBJECT
public:
  DialogImages ( QWidget *, const char *n=0, WFlags f=0 );
  virtual ~DialogImages ( );

  QValueList<CXmlSlideshow *> &getSlideshows ( );

protected slots:
  virtual void slotEditGroup ( );

protected:
  void initMe ( );

  virtual QString getDirFilter    ( );
  virtual void load ( QStringList & );


private:
  QValueList<CXmlSlideshow *> m_listOfSlideshows;

};

}; // end namespace Input

#endif // __DIALOGIMAGES_H__

